*****	MBS1 COPY MEMORY and 2D SECTOR *****
*****	Version 0.1

***** obt@BUFFER
***** n16bytes : C H R N + 12bytes
***** 128/256oCg(PZN^̃f[^)

	ORG $C000
*****	SETDP $C0
FD_BUFFER	EQU $0000
FD_NMIVEC	EQU $EEF5
FD_FDCSEL	EQU $FF00
BMSK_COLOR	EQU $FE20
ACTIVE_PLANE	EQU $FE21
COLOR1		EQU $01
COLOR2		EQU $02
TRACKMAX	EQU 40
SECTORMAX	EQU 16

KB		EQU $FFE0
VRAM		EQU $4000
CREG		EQU $FFD8


	BRA START

**** $C002

FUNCNUM		FCB $00
ARG1		FCB $00
RETCODEH	FCB $00		: RETCODE H
RETCODEL	FCB $00		: RETCODE L

**** $C006

FD_DRIVENUM	FCB 0
FD_TRACKNUM	FCB 0
FD_UNITNUM	FCB 0	: $FF04ɃZbgl
FD_STATUS_MSK	FCB 0
FD_RESERVED0	FCB $00
FD_NMIVEC_BUF	FDB $0000
FD_WRITESIZE	FDB $0000

FD_RESERVED1	FCB $00

**** $C010

FF_WRITEADDR	FDB $0000
FF_READADDR	FDB $0000

**** $C014

FD_WPROTECT	FCB 0
FD_RESERVED2	FCB 0

****

D88_OFFSET0	FCB 0
D88_OFFSET1	FCB 0
D88_OFFSET2	FCB 0
D88_OFFSET3	FCB 0

****

YMS_BAUD	FCB $00
YMS_SEQNO	FCB $00
YMS_RETCODE	FDB $0000
YMS_CRCDATH	FCB $00
YMS_CRCDATL	FCB $00
YMS_SENDTYPE	FCB $01
YMS_SENTSIZE	FDB $0000

*****

START
	PSHS CC,A,B,DP,X,Y,U
	LDD 2,X
	STD FUNCNUM

	CLR RETCODEH
	CLR RETCODEL
	ANDA #$F0
	CMPA #$20
	LBEQ YMS_START
	CMPA #$10
	LBEQ FF_START
	BRA FD_START
END
	**** RETURN CODE (INTEGER)
	LDX 4,S
	LDD RETCODEH
	STD 2,X
	PULS CC,A,B,DP,X,Y,U
	RTS

****

FD_START
	LDU #FD_FDCSEL
	CLR 4,U

	LDA FUNCNUM
	CMPA #$06
	LBEQ FD_ONE_TRACK
	CMPA #$04
	BEQ FD_FINISHED
	CMPA #$03
	BEQ FD_FINISHED
	CMPA #$02
	BEQ FD_READ_WRITE_DATA
	CMPA #$01
	BEQ FD_READ_WRITE_DATA

**** FUNCNUM $00
**** FDC 
FD_INITIALIZE
	LDD #$0000
****	STA FD_DRIVENUM
	STA FD_TRACKNUM
	STA FD_UNITNUM
	STA FD_STATUS_MSK
	STD FD_NMIVEC_BUF

	**** FORCEINT
	LBSR FDC_FORCEINT
	LBSR FD_NOTHING_TO_DO

	**** MOTOR ON
	CLRA
	BSR FD_MOTOR_ON
	LDA RETCODEL
	BMI FD_FINISHED		: NOT READY

	**** RESTORE
	LBSR FDC_RESTORE
	LDA RETCODEL
	BMI FD_FINISHED		: NOT READY
	ANDA #$40	: WRITE PROTECT
	LSRA
	LSRA
	STA FD_WPROTECT

	LDA RETCODEL
	ANDA #$04	: TRACK 0 ?
	BEQ FD_INITIALIZE

	BRA FD_FINISHED

**** FUNCNUM $01 ZN^
**** FUNCNUM $02 ZN^Ǎ
FD_READ_WRITE_DATA
	*** GET TRACK NUMBER
	LDX #FD_BUFFER
	LDB ,X
	CMPB #TRACKMAX
	BHS FD_FINISHED		: TRACK NUMBER TOO LARGE

	CLRA
****	CMPB #0			: 
****	BEQ FD_READ_WRITE_DATA_J1
	ORA #$20		: DOUBLE DENSITY
FD_READ_WRITE_DATA_J1
	LDB 1,X
	CMPB #0
	BEQ FD_READ_WRITE_DATA_J2
****	ORA #$30		: DOUBLE DENSITY & SIDE 1
	ORA #$10		: SIDE 1
FD_READ_WRITE_DATA_J2
	BSR FD_MOTOR_ON
	LDA RETCODEL
	BMI FD_FINISHED		: NOT READY

	**** SEEK
	LBSR FDC_SEEK
	LDA RETCODEL
	BITA #$81
	BNE FD_FINISHED		: NOT READY or BUSY

	**** READ or WRITE
	LBSR FDC_READ_WRITE
	LDA RETCODEL
	BITA #$81
	BNE FD_FINISHED		: NOT READY or BUSY

	BRA FD_FINISHED

FD_FINISHED
	**** MOTOR OFF
	BSR FD_MOTOR_OFF
	LBRA END


***** SWAP NMI VECTOR (SWAP VEC <-> VECB) *****
***** param[in] FD_NMIVEC_BUFɃWvZbgĂ

FD_SWAP_NMI_VEC
	PSHS X,Y
	LDX FD_NMIVEC
	LDY FD_NMIVEC_BUF
	STX FD_NMIVEC_BUF
	STY FD_NMIVEC
	PULS X,Y
	RTS

***** [^ON & hCuZNg
***** param[in] A: 0x10:head1 0x20:dden
***** param[in] FD_DRIVENUM
***** param[out] RETCODEL

FD_MOTOR_ON
	ORA FD_DRIVENUM
	ORA #$08
	STA FD_UNITNUM
	STA 4,U		*** MOTOR ON

	LDA #$80
	STA FD_STATUS_MSK
	BSR FD_WAIT_READY

	RTS

***** [^OFF
FD_MOTOR_OFF
	PSHS A
	LDA FD_DRIVENUM
	ANDA #$F7
	STA 4,U		*** MOTOR OFF
	PULS A
	RTS

***** ԉ҂

FD_NOTHING_TO_DO
	PSHS A
	LDA #$10
FD_NOTHING_TO_DO_LOOP
	CMPU #$0
	NOP
	DECA
	BNE FD_NOTHING_TO_DO_LOOP
	PULS A
	RTS

***** READY܂
***** param[in] FD_STATUS_MSK:0x80:NOT READY 0x01:BUSY 0x81:
***** param[out] RETCODEH>0 ESCL[ RETCODEL

FD_WAIT_READY
	CLR RETCODEH
	CLR RETCODEL
	PSHS A,X
FD_WAIT_READY_LOOP
	LDX #$FFFF
FD_WAIT_READY_CHECK
	LDA KB
	CMPA #$8C	: ESC key
	BNE FD_WAIT_READY_CHECK_FDC
	INC RETCODEH
	BRA FD_WAIT_READY_END

FD_WAIT_READY_CHECK_FDC
	LDA ,U
	COMA
	BITA FD_STATUS_MSK
	BEQ FD_WAIT_READY_END

FD_WAIT_READY_WAITING
	BSR FD_NOTHING_TO_DO

	LEAX -1,X
	BNE FD_WAIT_READY_CHECK

****	LEAY -1,Y
****	BNE FD_WAIT_READY_LOOP

FD_WAIT_READY_END
	STA RETCODEL
	PULS A,X
	RTS

***** FDC R}ho
***** param[in] AɃR}h

FDC_COMMAND
	COMA
	STA ,U
	NOP
	RTS

***** FORCEINT

FDC_FORCEINT
	LDA #$D0
	BSR FDC_COMMAND
	LDA ,U
	LDA 1,U
	LDA 2,U
	LDA 3,U
	RTS

***** RESTORE

FDC_RESTORE
	PSHS X
	LEAX FDC_RESTORE_FINISH,PCR
	STX FD_NMIVEC_BUF
	LBSR FD_SWAP_NMI_VEC
	PULS X

	LDA #$00
	ORCC #$50
	BSR FDC_COMMAND

	LDA #$01
	STA FD_STATUS_MSK
	BSR FD_WAIT_READY

FDC_RESTORE_PREFINISH
	ANDCC #$AF
	CLR FD_TRACKNUM

	RTS

FDC_RESTORE_FINISH
	LBSR FD_SWAP_NMI_VEC
	RTI


***** SEEK

FDC_SEEK
	PSHS X
	LEAX FDC_SEEK_FINISH,PCR
	STX FD_NMIVEC_BUF
	LBSR FD_SWAP_NMI_VEC
	PULS X

	LDA FD_TRACKNUM	: CURRENT TRACK NUMBER
	COMA
	STA 1,U
	LDA ,X		: NEXT TRACK NUMBER
	COMA
	STA 3,U

	LDA #$14
	ORCC #$50
	BSR FDC_COMMAND

	LDA #$81
	STA FD_STATUS_MSK
	LBSR FD_WAIT_READY

FDC_SEEK_PREFINISH
	ANDCC #$AF
	LDA 1,U		: SEEKED FD_TRACKNUM NUMBER
	COMA
	STA FD_TRACKNUM

	RTS

FDC_SEEK_FINISH
	LBSR FD_SWAP_NMI_VEC
	RTI

***** AFTER READ or WROTE

FDC_READ_WRITE_FINISH
	LEAS 12,S : 荞ݗp̃X^bNj
	PULS DP  : ޔĂDP߂

	LBSR FD_SWAP_NMI_VEC : NMIxN^߂

****	LDA FD_UNITNUM
****	ANDA #$7F
****	STA 4,U		: FDC ACCESS OK

	LDA #$81
	STA FD_STATUS_MSK
	LBSR FD_WAIT_READY

	LDB FUNCNUM
	ANDB #$0F
	CMPB #$01
	BEQ FDC_READ_WRITE_FINISH_J1

	**** READ
	STX FD_WRITESIZE : [hTCY
	BSR MEMCOM : f[^e𔽓]

FDC_READ_WRITE_FINISH_J1

	ANDCC #$AF

	RTS

***** e𔽓]
MEMCOM
	LDX #FD_BUFFER
	LEAX 16,X
MEMCOM_LOOP
	CMPX FD_WRITESIZE
	BHS MEMCOM_END
	LDA ,X
	COMA
	STA ,X+
	BRA MEMCOM_LOOP

MEMCOM_END
	RTS

***** READ or WRITE

FDC_READ_WRITE
	PSHS X
	LEAX FDC_READ_WRITE_FINISH,PCR
	STX FD_NMIVEC_BUF
	LBSR FD_SWAP_NMI_VEC
	PULS X

	LDA 2,X		: NEXT SECTOR NUMBER
	COMA
	STA 2,U

	CLR BMSK_COLOR
	LDB #COLOR2
	STB ACTIVE_PLANE

	PSHS DP  : DPޔ
	LDB #$FF
	TFR B,DP

	LEAX 16,X	: f[^16oCgڂ

	LDB FUNCNUM
	ANDB #$0F
	CMPB #$02
	BEQ FDC_READ

***** WRITE SECTOR

FDC_WRITE
	BSR MEMCOM : f[^e𔽓]

	LDA #$A0
	ORCC #$50
	LBSR FDC_COMMAND

****	LDA FD_UNITNUM
****	ORA #$88
****	STA 4,U		: FDC ACCESS NG

	LDB ,X+		: READ DATA
FDC_WRITE_J1
	FCB $96,$04	: LDA 4,DP	: WAIT DRQ
	BMI FDC_WRITE_J1

	FCB $D7,$03	: STB 3,DP	: WRITE DATA
	LDB ,X+		: READ NEXT DATA
	BRA FDC_WRITE_J1	: NMI荞݂܂Ń[v

***** READ SECTOR

FDC_READ
	LDA #$80
	ORCC #$50
	LBSR FDC_COMMAND

****	LDA FD_UNITNUM
****	ORA #$88
****	STA 4,U		: FDC ACCESS NG

FDC_READ_J1
	FCB $96,$04	: LDA 4,DP	: WAIT DRQ
	BMI FDC_READ_J1

	FCB $D6,$03	: LDB 3,DP	: READ DATA
	STB ,X+				: WRITE DATA
	BRA FDC_READ_J1	: NMI荞݂܂Ń[v

*****
CURSOR_X	EQU $E6B2
CURSOR_Y	EQU $E6B3
WIDTH		EQU $EFA2

FD_HNUM		FCB $00
FD_RNUM		FCB $00
FD_NNUM		FCB $00
FD_RETRY	FCB $00

FD_ONE_TRACK_ARGS	FCB $0,$0,$0,$0

FD_ONE_TRACK
	CLR FD_HNUM
FD_ONE_TRACK_LOOP_H
	CLR BMSK_COLOR
	LDB #COLOR2
	STB ACTIVE_PLANE

	LDX #FD_BUFFER
	LDA #$01
	STA FD_NNUM
***	LDA ,X : ' TRACK NUM
***	TSTA
***	BNE FD_ONE_TRACK_J1
***	LDA FD_HNUM	: ' HEAD NUM
***	BNE FD_ONE_TRACK_J1
***	CLR FD_NNUM
FD_ONE_TRACK_J1
	LDA #$01
	STA FD_RNUM
FD_ONE_TRACK_LOOP_R
	LBSR CURSOR_TO_ADDR
	LDD #$5247	: 'R'
	STB CREG
	STA ,X
	LDB #COLOR2
	STB ACTIVE_PLANE
	LDX #FD_BUFFER
	LDA FD_HNUM
	STA 1,X
	LDA FD_RNUM
	STA 2,X
	LDB FD_NNUM
	STB 3,X
	LDA #SECTORMAX
	STA 4,X
	CLR 5,X

	CLR 6,X
	CLR 14,X
	LDA #$01
	STA 15,X
	TSTB	: 'N
	BNE FD_ONE_TRACK_J2
	*** single density
	LDA #$40
	STA 6,X
	LDA #$80
	STA 14,X
	CLR 15,X

FD_ONE_TRACK_J2
	CLR FD_RETRY
	LDX #FD_ONE_TRACK_ARGS
FD_ONE_TRACK_J2_RETRY
	LDD #$0200
	STD 2,X
	LBSR START
	LDA 3,X		: RETURN CODE
	TSTA
	BEQ FD_ONE_TRACK_J3_OK : 'OK
	LDA FD_RETRY
	INCA
	STA FD_RETRY
	CMPA #$3
	BLO FD_ONE_TRACK_J2_RETRY

	LDA 3,X
	BITA #$80
	BNE FD_ONE_TRACK_J3_ABORT
	BITA #$10
	BNE FD_ONE_TRACK_J3_NOTFOUND
	BITA #$08
	BNE FD_ONE_TRACK_J3_CRCERR
	BITA #$04
	BNE FD_ONE_TRACK_J3_LOSTDATA

FD_ONE_TRACK_J3_OK
	LDB #$47
	LDA #$6F	: 'o'
	BRA FD_ONE_TRACK_J3
FD_ONE_TRACK_J3_NOTFOUND
	LDA #$46	: 'F'
	BRA FD_ONE_TRACK_J3_ERR
FD_ONE_TRACK_J3_CRCERR
	LDB #$46
	LDA #$43	: 'C'
	BRA FD_ONE_TRACK_J3
FD_ONE_TRACK_J3_LOSTDATA
	LDA #$4C	: 'L'
	BRA FD_ONE_TRACK_J3_ERR

FD_ONE_TRACK_J3_ABORT
	LDA #$80
	STA RETCODEL
	BRA FD_ONE_TRACK_END

FD_ONE_TRACK_J3_ERR
	LDB #$42

	PSHS A,B,Y,U
	LDB FD_NNUM
	TSTB
	BEQ FD_ONE_TRACK_J3_ERR_J1
	LDY #256
	BRA FD_ONE_TRACK_J3_ERR_J2
FD_ONE_TRACK_J3_ERR_J1
	LDY #128
FD_ONE_TRACK_J3_ERR_J2
	LDU #FD_BUFFER
	LEAU 16,U
	LDA #$40
	LDB #COLOR2
	LBSR MEMSET	: ' obt@𖄂߂
	STU FD_WRITESIZE
	PULS A,B,Y,U

FD_ONE_TRACK_J3
	BSR CURSOR_TO_ADDR
	STB CREG
	STA ,X
	INC CURSOR_X

FD_ONE_TRACK_COPY
	LDX #FD_ONE_TRACK_ARGS
	LDD #$1000
	STD 2,X
	LBSR START

	LDA FD_RNUM
	INCA
	STA FD_RNUM
	CMPA #SECTORMAX
	LBLS FD_ONE_TRACK_LOOP_R

	LDA FD_HNUM
	INCA
	STA FD_HNUM
	CMPA #$01
	LBLS FD_ONE_TRACK_LOOP_H

FD_ONE_TRACK_END
	LBRA END

*****
CURSOR_TO_ADDR
	PSHS A,B
	LDA WIDTH
	LDB CURSOR_Y
	MUL
	ADDB CURSOR_X
	ADCA #$0
	ADDD #VRAM
	TFR D,X
	PULS A,B
	RTS

*****
***** Rs[ *****
*****

****	ORG $C360
****	SETDP $C0
FF_DSTSTADDR	EQU $0000
FF_DSTEDADDR	EQU $4000

FF_EOF		EQU $1A

****    FUNCNUM $10:Rs[
****    FUNCNUM $11:Vtg
****    FUNCNUM $12:D88wb_쐬
****    FUNCNUM $13:NA

FF_START
	CLR BMSK_COLOR
	LDA #COLOR1
	STA ACTIVE_PLANE

	LDA FUNCNUM
	CMPA #$13
	BEQ FF_CLEAR_FUNCTION
	CMPA #$12
	BEQ D88_MAKE_HEADER
	CMPA #$11
	BEQ FF_SHIFT_FUNCTION

****

FF_COPY_FUNCTION
	LDU FF_WRITEADDR
	LDX #FD_BUFFER
****	LEAX 16,X
	LDD FD_WRITESIZE
	SUBD #FD_BUFFER
	BLS FF_COPY_END
	TFR D,Y
	LBSR MEMCPY
	STU FF_WRITEADDR
FF_COPY_END
	LBRA END

****

FF_CLEAR_FUNCTION
	LDU #FF_DSTSTADDR
	STU FF_READADDR
	LDY #128
	LDB #COLOR1
	CLRA
	LBSR MEMSET
	STU FF_WRITEADDR
FF_CLEAR_END
	LBRA END

****

FF_SHIFT_FUNCTION

FF_SHIFT_START
	LDX #FF_DSTSTADDR
	LDU FF_READADDR
	CMPU FF_WRITEADDR
	BHS FF_SHIFT_END
FF_SHIFT_LOOP
	LDA ,U+
	STA ,X+
	CMPU FF_WRITEADDR
	BNE FF_SHIFT_LOOP

	STX FF_WRITEADDR
	LDU #FF_DSTSTADDR
	STU FF_READADDR

FF_SHIFT_LOOP2
	CLR ,X+
	CMPX #FF_DSTEDADDR
	BNE FF_SHIFT_LOOP2

FF_SHIFT_END

FF_END
	LBRA END


*****
***** D88 HEADER
*****

D88_MAKE_HEADER
	LDX #FF_DSTSTADDR
	LDB #26
D88_MAKE_HEADER_LOOP1
	CLR ,X+
	DECB
	BNE D88_MAKE_HEADER_LOOP1

	LDA FD_WPROTECT
	STA ,X+

	LDA #$00
	STA ,X+		: fBXN $00:2D

**** fBXNTCY 
**** 688
**** + (40track * 2head * 16sector * (256bytes + 16bytes header)) -> 348160
**** =  (552B0)
**** little endien
	LDA #$B0
	STA ,X+
	LDA #$52
	STA ,X+
	LDA #$05
	STA ,X+
	LDA #$00
	STA ,X+

**** ItZbg 164tracks
D88_MAKE_HEADER_OFFSET
	LDU #D88_OFFSET0
	CLR ,U
	CLR 1,U
	LDA #$2
	STA 2,U
	LDA #$B0
	STA 3,U

	LDB #164

D88_MAKE_HEADER_LOOP2
	LDA 3,U
	STA ,X+
	LDA 2,U
	STA ,X+
	LDA 1,U
	STA ,X+
	LDA ,U
	STA ,X+

	**** calc next offset
	CMPB #86
	BLO D88_MAKE_HEADER_ZERO
****	CMPB #164
	BRA D88_MAKE_HEADER_DOUBLE
D88_MAKE_HEADER_SINGLE
	**** add (128+16)*16=2304 $900
	LDA 3,U
	ADDA #$00
	STA 3,U
	LDA 2,U
	ADCA #$09
	STA 2,U
	LDA 1,U
	ADCA #$00
	STA 1,U
	LDA ,U
	ADCA #$00
	STA ,U
	BRA D88_MAKE_HEADER_OFFSET1
D88_MAKE_HEADER_DOUBLE
	**** add (256+16)*16=4352 $1100
	LDA 3,U
	ADDA #$00
	STA 3,U
	LDA 2,U
	ADCA #$11
	STA 2,U
	LDA 1,U
	ADCA #$00
	STA 1,U
	LDA ,U
	ADCA #$00
	STA ,U
	BRA D88_MAKE_HEADER_OFFSET1
D88_MAKE_HEADER_ZERO
	CLR 3,U
	CLR 2,U
	CLR 1,U
	CLR ,U
D88_MAKE_HEADER_OFFSET1
	DECB
	BNE D88_MAKE_HEADER_LOOP2

D88_MAKE_HEADER_END
	STX FF_WRITEADDR
	LDX #FF_DSTSTADDR
	STX FF_READADDR

	LBRA END

***** Zbg
***** U:dst A:f[^ Y:oCg B:VRAMv[
***** return A:$0 A:$FF I[o[
MEMSET
MEMSET_LOOP
	CMPU #FF_DSTEDADDR
	BEQ MEMCPY_OVERBUFFER

	STB ACTIVE_PLANE
	STA ,U+
	LEAY -1,Y
	BNE MEMSET_LOOP
	BRA MEMCPY_SUCCESS

***** Rs[
***** X:src U:dst Y:oCg
***** return A:$0 A:$FF I[o[
MEMCPY
MEMCPY_LOOP
	CMPU #FF_DSTEDADDR
	BEQ MEMCPY_OVERBUFFER

	LDB #COLOR2
	STB ACTIVE_PLANE
	LDA ,X+
	LDB #COLOR1
	STB ACTIVE_PLANE
	STA ,U+
	LEAY -1,Y
	BNE MEMCPY_LOOP
MEMCPY_SUCCESS
	CLRA
	FCB $8C	: dummy
MEMCPY_OVERBUFFER
	LDA #$FF
MEMCPY_END
	RTS

*****
***** YMODEMőM *****
*****

***** obt@VGRAM BLUE

****	ORG $C570
****	SETDP $C0
YMS_BUFFERST	EQU $0000
YMS_SENDSIZE1	EQU 128
YMS_SENDSIZE2	EQU 1024
ACIA_STAT	EQU $FFC4
ACIA_DATA	EQU $FFC5
MODE_BA		EQU $EB9A
MODESEL		EQU $FFD0

**** PROTOCOL YMODEM

YM_ACK	EQU $06
YM_NAK	EQU $15
YM_CAN	EQU $18

YM_SOH	EQU $01
YM_STX	EQU $02
YM_EOT	EQU $04

YM_EOF	EQU $1A

YM_REQ	EQU $43	: 'C'

****

YMS_START
	LDA FUNCNUM
	CMPA #$2F
	BEQ YMS_TERMINATE
	CMPA #$21
	BEQ YMS_SEND_FUNCTION

**** FUNCNUM $20
**** {[[gݒ
**** ARG1=1: 1/16 2:1/64

YMS_INITIALIZE
	LDA MODE_BA
	ORA #$20
	STA MODESEL

	LDA #$3
	STA ACIA_STAT
	NOP
	LDA ARG1
	ANDA #$3
	ORA #$10	; 8bit no parity
	STA ACIA_STAT

	LBRA END

**** FUNCNUM $2F
**** I

YMS_TERMINATE
	LDA MODE_BA
	ANDA #$DF
	STA MODESEL

	LBRA END

**** FUNCNUM $21
**** M
**** ARG1: $00:(ubN0:t@C)  $01:ŏ̃f[^(ubN1) $02:𑗂 $03:Ō𑗂 $04:EOT𑗂
**** RETURN: 0:f[^ $ff:LZ

YMS_SEND_FUNCTION
	**** DISABLE IRQ AND FIRQ
	ORCC #$50
	CLR BMSK_COLOR
	LDA #COLOR1
	STA ACTIVE_PLANE

	LDA ARG1
	CMPA #$04
	LBEQ YMS_SEND_EOT
	CMPA #$03
	LBEQ YMS_SEND_LAST
	CMPA #$02
	BEQ YMS_SEND_NEXT
	CMPA #$01
	BEQ YMS_SEND_FIRST

YMS_SEND_FILE
	**** ubN0
	CLR YMS_SEQNO
	LDA #YM_SOH
	STA YMS_SENDTYPE
	LDD #YMS_SENDSIZE1
	STD YMS_SENTSIZE
	BRA YMS_SEND_REQ_WAIT

YMS_SEND_FIRST
	**** ubN1
	LDA #$01
	STA YMS_SEQNO
	LDA #YM_STX
	STA YMS_SENDTYPE
	LDD #YMS_SENDSIZE2
	STD YMS_SENTSIZE
	LDD #YMS_BUFFERST
	STD FF_READADDR

	BSR YMS_SEND_DATA_IS_FILLED

YMS_SEND_REQ_WAIT
	**** Mv҂
	LBSR YMS_WAIT_RECV_1BYTE
	CMPA #YM_REQ
	BEQ YMS_SEND_SOHSTX

	CMPA #YM_CAN
	LBEQ YMS_SEND_CANCEL_END2
	BRA YMS_SEND_REQ_WAIT


YMS_SEND_DATA_IS_FILLED
	LDD FF_READADDR
	ADDD YMS_SENTSIZE
	ADDD #$01
	CMPD FF_WRITEADDR
	BLO YMS_SEND_DATA_IS_FILLED_OK
YMS_SEND_DATA_SHORT
	LEAS 2,S : PĈĂ
	LDA #$02
	STA RETCODEL
	LBRA YMS_SEND_END
YMS_SEND_DATA_IS_FILLED_OK
	RTS

YMS_SEND_DATA_PADDING
	LDD FF_WRITEADDR
	SUBD FF_READADDR
	BLS YMS_SEND_DATA_SHORT
	LDD FF_READADDR
	ADDD YMS_SENTSIZE
	SUBD FF_WRITEADDR
	BLS YMS_SEND_DATA_PADDING_END
	TFR D,Y
	LDU FF_WRITEADDR
	LDA #YM_EOF
YMS_SEND_DATA_PADDING_LOOP1
	STA ,U+
	LEAY -1,Y
	BNE YMS_SEND_DATA_PADDING_LOOP1
	STU FF_WRITEADDR
YMS_SEND_DATA_PADDING_END
	RTS


YMS_SEND_NEXT
	BSR YMS_SEND_DATA_IS_FILLED
	**** LZMH
	LBSR YMS_RECV_1BYTE
	CMPA #YM_CAN
	LBEQ YMS_SEND_CANCEL_END2
	BRA YMS_SEND_INC_SEQNO

YMS_SEND_LAST
	BSR YMS_SEND_DATA_PADDING
	BRA YMS_SEND_INC_SEQNO

YMS_SEND_INC_SEQNO
	INC YMS_SEQNO

YMS_SEND_SOHSTX
	**** SOH or STX𑗐M ubNJn
	LBSR YMS_WAIT_SEND_OK
	LDA YMS_SENDTYPE
	STA ACIA_DATA

YMS_SEND_SEQNO
	**** V[PXԍ𑗐M
	LDA YMS_SEQNO
	LBSR YMS_WAIT_SEND_OK
	STA ACIA_DATA
	COMA
	LBSR YMS_WAIT_SEND_OK
	STA ACIA_DATA

YMS_SEND_DATA
	**** f[^𑗐M
	LDU FF_READADDR
	LDY YMS_SENTSIZE
	CLRA
	CLRB
	STD YMS_CRCDATH	; for CRC

YMS_SEND_DATA_LOOP1
	LDA ,U+
	LBSR CALC_CRC16
	LBSR YMS_WAIT_SEND_OK
	STA ACIA_DATA
	LEAY -1,Y
	BNE YMS_SEND_DATA_LOOP1

YMS_SEND_CRC
	**** CRCvZ
	CLRA
	LBSR CALC_CRC16
	LBSR CALC_CRC16

	**** CRC𑗐M
	LDA YMS_CRCDATH
	LBSR YMS_WAIT_SEND_OK
	STA ACIA_DATA

	LDA YMS_CRCDATL
	LBSR YMS_WAIT_SEND_OK
	STA ACIA_DATA

YMS_SEND_OK
	**** PubNM
	**** ACK or NAK ܂
	LBSR YMS_WAIT_RECV_1BYTE
	CMPA #YM_NAK
	BEQ YMS_SEND_RETRY
	CMPA #YM_CAN
	BEQ YMS_SEND_CANCEL_END2
	CMPA #YM_ACK
	BNE YMS_SEND_OK

	STU FF_READADDR

	BRA YMS_SEND_END

YMS_SEND_RETRY
	**** đM
	LBSR YMS_WAIT_LOOP
	BRA YMS_SEND_SOHSTX

YMS_SEND_EOT
	**** f[^MI
	BSR YMS_WAIT_SEND_OK
	LDA #YM_EOT
	STA ACIA_DATA

	**** ACK or NAK ܂
	BSR YMS_WAIT_RECV_1BYTE
	CMPA #YM_NAK
	BEQ YMS_SEND_EOT

	BRA YMS_SEND_END_WAIT

YMS_SEND_CANCEL_END
	**** SEND CAN
	LDA #YM_CAN
	BSR YMS_WAIT_SEND_OK
	STA ACIA_DATA
	BSR YMS_WAIT_SEND_OK
	STA ACIA_DATA

YMS_SEND_CANCEL_END2
	**** RETURN CODE
	LDA #$FF
	STA RETCODEL

	BRA YMS_SEND_END_WAIT

YMS_SEND_END_WAIT
	**** WAIT
	LBSR YMS_WAIT_LOOP

YMS_SEND_END
	**** ENABLE IRQ AND FIRQ
	ANDCC #$AF

	LBRA END


**** CRC16vZ
**** A: f[^1oCg 
CALC_CRC16
	PSHS A,B,X
	LDX #$8
CALC_CRC16_LOOP1
	LSLA
	ROL YMS_CRCDATL
	ROL YMS_CRCDATH
	BCC CALC_CRC16_NEXT

CALC_CRC16_MINUS
	LDB YMS_CRCDATL
	EORB #$21
	STB YMS_CRCDATL
	LDB YMS_CRCDATH
	EORB #$10
	STB YMS_CRCDATH

CALC_CRC16_NEXT
	LEAX -1,X
	BNE CALC_CRC16_LOOP1

CALC_CRC16_END
	PULS A,B,X
	RTS

****
**** ACIAM҂
****

YMS_WAIT_SEND_OK
	PSHS B
YMS_WAIT_SEND_OK_LOOP1
	LDB ACIA_STAT
	ANDB #$02
	BEQ YMS_WAIT_SEND_OK_LOOP1
	PULS B
	RTS

****
**** 1oCgM҂
****

YMS_WAIT_RECV_1BYTE
	PSHS Y
	LDA #$47
	STA CREG
	CLR VRAM
	LDX #60
	LDY #0
	BSR YMS_WAIT_RECV_LOOP
	TSTA
	BNE YMS_WAIT_RECV_1BYTE_CANCEL_END
	LDA ACIA_DATA
	STA VRAM
	PULS Y
	RTS

YMS_WAIT_RECV_1BYTE_CANCEL_END
	LEAS 4,S	: pushY,PĈĂ
	BRA YMS_SEND_CANCEL_END

**** 1oCgMĂ邩

YMS_RECV_1BYTE
	PSHS Y
	LDA #$47
	STA CREG
	CLR VRAM
	LDX #$01
	LDY #$02
	BSR YMS_WAIT_RECV_LOOP
	CMPA #$FF
	BEQ YMS_WAIT_RECV_1BYTE_CANCEL_END
	TSTA
	BNE YMS_RECV_1BYTE_J1
	LDA #$47
	STA CREG
	LDA ACIA_DATA
	STA VRAM
	BRA YMS_RECV_1BYTE_J2
YMS_RECV_1BYTE_J1
	CLRA
YMS_RECV_1BYTE_J2
	PULS Y
	RTS

**** M܂
**** X: TIMEOUT
**** return: A=1:timeout A=$FF break key pushed

YMS_WAIT_RECV_LOOP
	PSHS B
YMS_WAIT_RECV_LOOP1
	LEAY ,-Y
	BNE YMS_WAIT_RECV_LOOP_J1
	LEAX ,-X
	BEQ YMS_WAIT_RECV_LOOP_TIMEOUT
YMS_WAIT_RECV_LOOP_J1
	LDB ACIA_STAT
	BITB #$01
	BNE YMS_WAIT_RECV_LOOP_RECVED
	LDB KB
	CMPB #$8C
	BNE YMS_WAIT_RECV_LOOP1
YMS_WAIT_RECV_LOOP_CANCEL
	LDA #$FF
	BRA YMS_WAIT_RECV_LOOP_END
YMS_WAIT_RECV_LOOP_TIMEOUT
	LDA #$01
	BRA YMS_WAIT_RECV_LOOP_END
YMS_WAIT_RECV_LOOP_RECVED
	LDA #$00
YMS_WAIT_RECV_LOOP_END
	PULS B
	RTS

**** 983,040 + 7+3+7+5 us (1MHz)

YMS_WAIT_LOOP
	PSHS X			; 7
	LDX #$0
YMS_WAIT_LOOP_J1
	LEAX ,-X		; 6
	LEAX ,X			; 4
	NOP			; 2
	BNE YMS_WAIT_LOOP_J1	; 3
	PULS X			; 7
	RTS			; 5


*****
***** t@CZbg
***** ̓t@C ϐ

	ORG $C6A0
****	SETDP $C0

SET_FILENAME
	PSHS CC,A,B,DP,X,Y,U
	TFR S,U
	SWI2
	FCB $41,$37 : ANTITO Rs[
	PSHS U
	PSHS B

	LDU #FF_DSTSTADDR
	CLR BMSK_COLOR
	LDA #COLOR1
	STA ACTIVE_PLANE
SET_FILENAME_LOOP1
	TSTB
	BEQ SET_FILENAME_LOOP1_END
	LDA ,X+
	STA ,U+
	DECB
	BRA SET_FILENAME_LOOP1
SET_FILENAME_LOOP1_END
	LDB #128
	SUBB ,S : Z
SET_FILENAME_LOOP2
	TSTB
	BEQ SET_FILENAME_LOOP2_END
	CLR ,U+
	DECB
	BRA SET_FILENAME_LOOP2
SET_FILENAME_LOOP2_END
	STU FF_WRITEADDR
	LDD #FF_DSTSTADDR
	STD FF_READADDR
	PULS B,U
	TFR U,S
SET_FILENAME_END
	PULS CC,A,B,DP,X,Y,U
	RTS
